/* 
    kleds for KDE2/KDE3

    Copyright (C) 2001 Hans Matzen (hans@hansmatzen.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __DOCKWIDGET_H
#define __DOCKWIDGET_H

#include <qwidget.h>
#include <qcolor.h>
#include <qfont.h>
#include <qtooltip.h>
#include <kwin.h>
#include <qlabel.h>
#include <kled.h>
#include <ksystemtray.h>

class dockwidget;
#include "kleds.h"

class dockwidget : public QWidget { 
/* class dockwidget : public KSystemTray { */
	Q_OBJECT
public:

	dockwidget(QWidget *mainwin = 0, QWidget *parent = 0, 
		   const char *name = 0);
	~dockwidget();

	void config_numled(KLed::Shape s,QColor col);
	void config_capsled(KLed::Shape s,QColor col);
	void config_scrollled(KLed::Shape s,QColor col);
	void config_layout(uint labpos);
	void config_background(uint bg_typ, QColor col);
	void config_font(QFont font);

private:
	KLed *scroll_led;
	KLed *num_led;
	KLed *caps_led;
	QLabel *num_label;
	QLabel *caps_label;
	QLabel *scroll_label;
	int ledstate;

	void mousePressEvent(QMouseEvent *);

public slots:
	void set_LEDS(int state);

signals:
        void mouseClick(QMouseEvent *);
};
#endif





