/* 
    kleds for KDE2/KDE3

    Copyright (C) 2001,2002 by Hans Matzen (hans@hansmatzen.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
//
// main program for kleds
//

#include "../config.h"


extern "C" {
#include <stdlib.h>
#include <unistd.h>
}

#include "kleds.h"

#include <qobject.h>
#include <kuniqueapp.h>
#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <kglobal.h>
#include <klocale.h>
#include <dcopclient.h>
#include <qcstring.h>
#include <qdatastream.h>
#include <qcstring.h>

static const char *description = 
       I18N_NOOP("A keyboard LED indicator for kicker.");
static const char *version = VERSION;

int main(int argc,char **argv) 
{
    // start the gui
    
    KAboutData aboutData("kleds", "KLeds", version, description,
			 KAboutData::License_GPL,
			 "(c) 2001, 2002, 2003 Hans Matzen", 
			 (const char *) I18N_NOOP("KLeds is a keyboard LED indicator for KDE2/KDE3.\nIt is usefull if you use a keyboard without LED's\nsuch as the Logitech Cordless Desktop keyboard\nor just for fun because you like it."), 
			 "http://www.hansmatzen.de", "hans@hansmatzen.de");
    
    aboutData.addAuthor("Hans Matzen", I18N_NOOP("KLeds Developer"), 
			"hans@hansmatzen.de");
    KCmdLineArgs::init(argc,argv,&aboutData);
    
    KApplication app;
    
    // check if we are allready running
    // and terminate if yes
    QCString a,b;
    if (app.dcopClient()
	->findObject( "kleds","kleds","",0,a,b,true)) {
	printf("KLeds is already running. Exit.\n");
	exit(2);
   }

    KLeds *k = new KLeds(0,"KLeds");
    QCString appid;
    
    app.setMainWidget( (QWidget *) k);
    
    // register with dcop
    appid=app.dcopClient()->registerAs("kleds",false);
    
    // to prevent a button in the taskbar
    QByteArray params;
    QDataStream d(params, IO_WriteOnly);
    d << (int) getpid();
    
    app.dcopClient()
	->send("kicker", "TaskbarApplet", "clientDied(pid_t)",
	       params);
    
    // request current ledstate for init from xkb watcher
    //app.dcopClient()->
    //	send("kleds","kledsd","get_indicators()","");

    

    // start it
    app.exec();
    
    return 0;
}


