/* 
    kleds for KDE2/KDE3

    Copyright (C) 2001 Hans Matzen (hans@hansmatzen.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "prefs.h"

#include <kcolorbutton.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <klocale.h>
#include <kfontdialog.h>

Prefs::Prefs( QWidget* parent, const char* name, bool modal, WFlags fl )
    : KDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "KLeds Preferences" );
    resize( 360, 350 ); 
    setCaption( i18n("KLeds Preferences") );

    // the tabdialog
    TabWidget = new QTabWidget(this,"TabWidget1",0);
    TabWidget->setGeometry( QRect(10,10,340,280) );

    GroupBox1 = new QGroupBox( TabWidget, "GroupBox1" );
    GroupBox1->setGeometry( QRect( 0, 0, 320, 240 ) ); 

    // layout options
    TextLabel2_2 = new QLabel( GroupBox1, "TextLabel2_2" );
    TextLabel2_2->setGeometry( QRect( 10, 10, 80, 20 ) ); 
    TextLabel2_2->setText( i18n( "Num - LED:" ) );

    TextLabel2_2_2 = new QLabel( GroupBox1, "TextLabel2_2_2" );
    TextLabel2_2_2->setGeometry( QRect( 10, 40, 80, 20 ) ); 
    TextLabel2_2_2->setText( i18n( "Caps - LED:" ) );

    TextLabel2_2_2_2 = new QLabel( GroupBox1, "TextLabel2_2_2_2" );
    TextLabel2_2_2_2->setGeometry( QRect( 10, 70, 80, 20 ) ); 
    TextLabel2_2_2_2->setText( i18n( "Scroll - LED:" ) );

    TextLabel2 = new QLabel( GroupBox1, "TextLabel2" );
    TextLabel2->setGeometry( QRect( 10, 120, 100, 20 ) ); 
    TextLabel2->setText( i18n( "Label Position:" ) );

    TextLabel3 = new QLabel( GroupBox1, "TextLabel3" );
    TextLabel3->setGeometry( QRect( 10, 150, 100, 20 ) ); 
    TextLabel3->setText( i18n( "Background:" ) );

    TextLabel4 = new QLabel( GroupBox1, "TextLabel4" );
    TextLabel4->setGeometry( QRect( 10, 180, 100, 20 ) ); 
    TextLabel4->setText( i18n( "Font:" ) );

    // all for num led
    ComboBox1_2 = new QComboBox( FALSE, GroupBox1, "ComboBox1_2" );
    ComboBox1_2->insertItem( i18n( "circular" ) );
    ComboBox1_2->insertItem( i18n( "rectangular" ) );
    ComboBox1_2->setGeometry( QRect( 100, 10, 88, 22 ) ); 

    KColorButton1 = new KColorButton( GroupBox1, "KColorButton1" );
    KColorButton1->setGeometry( QRect( 200, 10, 80, 20 ) ); 

    // all for caps led
    ComboBox1_2_2_2 = new QComboBox( FALSE, GroupBox1, "ComboBox1_2_2_2" );
    ComboBox1_2_2_2->insertItem( i18n( "circular" ) );
    ComboBox1_2_2_2->insertItem( i18n( "rectangular" ) );
    ComboBox1_2_2_2->setGeometry( QRect( 100, 40, 88, 22 ) ); 
    
    KColorButton1_2 = new KColorButton( GroupBox1, "KColorButton1_2" );
    KColorButton1_2->setGeometry( QRect( 200, 40, 80, 20 ) ); 

    // all for scroll led
    ComboBox1_2_2 = new QComboBox( FALSE, GroupBox1, "ComboBox1_2_2" );
    ComboBox1_2_2->insertItem( i18n( "circular" ) );
    ComboBox1_2_2->insertItem( i18n( "rectangular" ) );
    ComboBox1_2_2->setGeometry( QRect( 100, 70, 88, 22 ) ); 

    KColorButton1_3 = new KColorButton( GroupBox1, "KColorButton1_3" );
    KColorButton1_3->setGeometry( QRect( 200, 70, 80, 20 ) ); 

    // the label position widget
    ComboBox1 = new QComboBox( FALSE, GroupBox1, "ComboBox1" );
    ComboBox1->insertItem( i18n( "Left" ) );
    ComboBox1->insertItem( i18n( "Right" ) );
    ComboBox1->insertItem( i18n( "Top" ) );
    ComboBox1->insertItem( i18n( "Bottom" ) );
    ComboBox1->setGeometry( QRect( 100, 120, 88, 22 ) ); 

    // all for background color chooser
    ComboBox3 = new QComboBox( FALSE, GroupBox1, "ComboBox3" );
    ComboBox3->insertItem( i18n( "use Palette" ) );
    ComboBox3->insertItem( i18n( "define own" ) );
    ComboBox3->setGeometry( QRect( 100, 150, 88, 22 ) ); 

    KColorButton3 = new KColorButton( GroupBox1, "KColorButton3" );
    KColorButton3->setGeometry( QRect( 200, 150, 80, 20 ) ); 
    KColorButton3->setEnabled(false);
    
    // all for font selection
    PushButton4 = new QPushButton( GroupBox1, "PushButton4" );
    PushButton4->setGeometry( QRect( 100, 180, 180, 20 ) ); 
    PushButton4->setText( i18n( "Choose Font" ) );

    //
    // second tab for key setup
    //
    GroupBox2 = new QGroupBox( TabWidget, "GroupBox2" );
    GroupBox2->setGeometry( QRect( 0, 0, 320, 240 ) ); 

    TextLabel1_1 = new QLabel( GroupBox2, "TextLabel1_1" );
    TextLabel1_1->setGeometry( QRect( 10, 10, 90, 20 ) ); 
    TextLabel1_1->setText( i18n( "Sleep - Key:" ) );

    TextLabel1_2 = new QLabel( GroupBox2, "TextLabel1_2" );
    TextLabel1_2->setGeometry( QRect( 10, 30, 90, 20 ) ); 
    TextLabel1_2->setText( i18n( "Mute - Key:" ) );

    TextLabel1_3 = new QLabel( GroupBox2, "TextLabel1_3" );
    TextLabel1_3->setGeometry( QRect( 10, 50, 90, 20 ) ); 
    TextLabel1_3->setText( i18n( "Vol Down - Key:" ) );

    TextLabel1_4 = new QLabel( GroupBox2, "TextLabel1_4" );
    TextLabel1_4->setGeometry( QRect( 10, 70, 90, 20 ) ); 
    TextLabel1_4->setText( i18n( "Vol Up - Key:" ) );

    TextLabel1_5 = new QLabel( GroupBox2, "TextLabel1_5" );
    TextLabel1_5->setGeometry( QRect( 10, 90, 90, 20 ) ); 
    TextLabel1_5->setText( i18n( "Play - Key:" ) );

    TextLabel1_6 = new QLabel( GroupBox2, "TextLabel1_6" );
    TextLabel1_6->setGeometry( QRect( 10, 110, 90, 20 ) ); 
    TextLabel1_6->setText( i18n( "Stop - Key:" ) );

    TextLabel1_7 = new QLabel( GroupBox2, "TextLabel1_7" );
    TextLabel1_7->setGeometry( QRect( 10, 130, 90, 20 ) ); 
    TextLabel1_7->setText( i18n( "Previous - Key:" ) );

    TextLabel1_8 = new QLabel( GroupBox2, "TextLabel1_8" );
    TextLabel1_8->setGeometry( QRect( 10, 150, 90, 20 ) ); 
    TextLabel1_8->setText( i18n( "Next - Key:" ) );

    TextLabel1_9 = new QLabel( GroupBox2, "TextLabel1_9" );
    TextLabel1_9->setGeometry( QRect( 10, 170, 90, 20 ) ); 
    TextLabel1_9->setText( i18n( "eMail - Key:" ) );

    TextLabel1_10 = new QLabel( GroupBox2, "TextLabel1_10" );
    TextLabel1_10->setGeometry( QRect( 10, 190, 90, 20 ) ); 
    TextLabel1_10->setText( i18n( "Search - Key:" ) );

    TextLabel1_11 = new QLabel( GroupBox2, "TextLabel1_11" );
    TextLabel1_11->setGeometry( QRect( 10, 210, 90, 20 ) ); 
    TextLabel1_11->setText( i18n( "Surf - Key:" ) );

    TextLabel1_12 = new QLabel( GroupBox2, "TextLabel1_12" );
    TextLabel1_12->setGeometry( QRect( 10, 230, 90, 20 ) ); 
    TextLabel1_12->setText( i18n( "Home - Key:" ) );

    LineEdit1_1 = new QLineEdit ( GroupBox2, "LineEdit1_1" );
    LineEdit1_1->setGeometry(QRect(120, 10, 150,20) );

    LineEdit1_2 = new QLineEdit ( GroupBox2, "LineEdit1_2" );
    LineEdit1_2->setGeometry(QRect(120, 30, 150,20) );

    LineEdit1_3 = new QLineEdit ( GroupBox2, "LineEdit1_3" );
    LineEdit1_3->setGeometry(QRect(120, 50, 150,20) );

    LineEdit1_4 = new QLineEdit ( GroupBox2, "LineEdit1_4" );
    LineEdit1_4->setGeometry(QRect(120, 70, 150,20) );

    LineEdit1_5 = new QLineEdit ( GroupBox2, "LineEdit1_5" );
    LineEdit1_5->setGeometry(QRect(120, 90, 150,20) );

    LineEdit1_6 = new QLineEdit ( GroupBox2, "LineEdit1_6" );
    LineEdit1_6->setGeometry(QRect(120, 110, 150,20) );

    LineEdit1_7 = new QLineEdit ( GroupBox2, "LineEdit1_7" );
    LineEdit1_7->setGeometry(QRect(120, 130, 150,20) );

    LineEdit1_8 = new QLineEdit ( GroupBox2, "LineEdit1_8" );
    LineEdit1_8->setGeometry(QRect(120, 150, 150,20) );

    LineEdit1_9 = new QLineEdit ( GroupBox2, "LineEdit1_9" );
    LineEdit1_9->setGeometry(QRect(120, 170, 150,20) );

    LineEdit1_10 = new QLineEdit ( GroupBox2, "LineEdit1_10" );
    LineEdit1_10->setGeometry(QRect(120, 190, 150,20) );

    LineEdit1_11 = new QLineEdit ( GroupBox2, "LineEdit1_11" );
    LineEdit1_11->setGeometry(QRect(120, 210, 150,20) );

    LineEdit1_12 = new QLineEdit ( GroupBox2, "LineEdit1_12" );
    LineEdit1_12->setGeometry(QRect(120, 230, 150,20) );

    // the okay and cancel buttons
    PushButton1 = new QPushButton( this, "PushButton1" );
    PushButton1->setGeometry( QRect( 20, 300, 102, 26 ) ); 
    PushButton1->setText( i18n( "Ok" ) );

    PushButton1_3 = new QPushButton( this, "PushButton1_3" );
    PushButton1_3->setGeometry( QRect( 240, 300, 102, 26 ) ); 
    PushButton1_3->setText( i18n( "Cancel" ) );

    // signals and slots connections
    connect( PushButton1, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( PushButton1_3, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( ComboBox3, SIGNAL( activated(int) ), this, 
	     SLOT( config_bgcolchooser(int) ) );
    connect( PushButton4, SIGNAL( clicked() ), this, 
	     SLOT( config_font() ) );

    // add the widgets into tab
    TabWidget->addTab(GroupBox1,"&Layout");
    TabWidget->addTab(GroupBox2,i18n("&Specialkeys"));
}

// destructor
Prefs::~Prefs(){}

void Prefs::cancel()
{
    this->reject();
}

void Prefs::ok()
{
    this->accept();
}


 /* methods for setting and getting the widget values */
KLed::Shape Prefs::get_num_shape()
{
    if (ComboBox1_2->currentText()==QString( i18n("circular")))
	return KLed::Circular;
    else
	return KLed::Rectangular;
}

KLed::Shape Prefs::get_caps_shape()
{ 
    if (ComboBox1_2_2_2->currentText()==QString( i18n("circular")))
	return KLed::Circular;
    else
	return KLed::Rectangular;
}

KLed::Shape Prefs::get_scroll_shape()
{ 
    if (ComboBox1_2_2->currentText()==QString( i18n("circular")))
	return KLed::Circular;
    else
	return KLed::Rectangular;
}

QColor Prefs::get_num_color()
{
    return KColorButton1->color();
}

QColor Prefs::get_caps_color()
{
    return KColorButton1_2->color();
}

QColor Prefs::get_scroll_color()
{
    return KColorButton1_3->color();
}

QColor Prefs::get_bg_color()
{
    return KColorButton3->color();
}

uint Prefs::get_bg_typ()
{
    return (uint) ComboBox3->currentItem();
}

uint Prefs::get_label_position()
{ 
    switch (ComboBox1->currentItem()) {
	case 0:
	    return LEFT;
	    break;
	case 1:
	    return RIGHT;
	    break;
	case 2:
	    return TOP;
	    break;
	case 3:
	    return BOTTOM;
	    break;
   }
    return 0;
}

void Prefs::set_num_shape(KLed::Shape shape)
{
    if (shape==1)
	ComboBox1_2->setCurrentItem(0);
    else
	ComboBox1_2->setCurrentItem(1);
}

void Prefs::set_scroll_shape(KLed::Shape shape)
{  
    if (shape==1)
	ComboBox1_2_2->setCurrentItem(0);
    else
	ComboBox1_2_2->setCurrentItem(1);
}

void Prefs::set_caps_shape(KLed::Shape shape)
{  
    if (shape==1)
	ComboBox1_2_2_2->setCurrentItem(0);
    else
	ComboBox1_2_2_2->setCurrentItem(1);
}

void Prefs::set_num_color(QColor col)
{
    KColorButton1->setColor(col);
}

void Prefs::set_caps_color(QColor col)
{
    KColorButton1_2->setColor(col);
}

void Prefs::set_scroll_color(QColor col)
{
    KColorButton1_3->setColor(col);
}

void Prefs::set_bg_color(uint typ, QColor col)
{   
    KColorButton3->setColor(col);
    if (typ==0)
	config_bgcolchooser(0);
    else {
	ComboBox3->setCurrentItem(1);
	config_bgcolchooser(1);
    }
}

void Prefs::set_label_position(uint labpos)
{
    ComboBox1->setCurrentItem(labpos);
}


void Prefs::config_bgcolchooser(int pos)
{
    if (pos==0)
	KColorButton3->setEnabled(false);
    else
	KColorButton3->setEnabled(true);
}

QFont Prefs::get_font()
{
    return *pref_font;
}

void Prefs::set_font(QFont font)
{
    pref_font = new QFont(font);
}

void Prefs::config_font()
{
    KFontDialog::getFont( *pref_font );
}

void Prefs::set_special_key_cmd(int key,QString cmd)
{
    switch (key) {
	case KLEDS_KEY_STANDBY:
	    LineEdit1_1->setText(cmd);
	    break;
	case KLEDS_KEY_MUTE:
	    LineEdit1_2->setText(cmd);
	    break;
	case KLEDS_KEY_LOWER:
	    LineEdit1_3->setText(cmd);
	    break;   
	case KLEDS_KEY_RAISE:
	    LineEdit1_4->setText(cmd);
	    break;   
	case KLEDS_KEY_PLAY:
	    LineEdit1_5->setText(cmd);
	    break;    
	case KLEDS_KEY_STOP:
	    LineEdit1_6->setText(cmd);
	    break;    
	case KLEDS_KEY_PREV:
	    LineEdit1_7->setText(cmd);
	    break;    
	case KLEDS_KEY_NEXT:
	    LineEdit1_8->setText(cmd);
	    break;    
	case KLEDS_KEY_MAIL:
	    LineEdit1_9->setText(cmd);
	    break;    
	case KLEDS_KEY_SEARCH:
	    LineEdit1_10->setText(cmd);
	    break;  
	case KLEDS_KEY_START:
	    LineEdit1_11->setText(cmd);
	    break;   
	case KLEDS_KEY_HOME:
	    LineEdit1_12->setText(cmd);
	    break;    
    }
}


QString Prefs::get_special_key_cmd(int key)
{
    switch (key) {
	case KLEDS_KEY_STANDBY:
	    return LineEdit1_1->text();
	    break;
	case KLEDS_KEY_MUTE:
	    return LineEdit1_2->text();
	    break;
	case KLEDS_KEY_LOWER:
	    return LineEdit1_3->text();
	    break;   
	case KLEDS_KEY_RAISE:
	    return LineEdit1_4->text();
	    break;   
	case KLEDS_KEY_PLAY:
	    return LineEdit1_5->text();
	    break;    
	case KLEDS_KEY_STOP:
	    return LineEdit1_6->text();
	    break;    
	case KLEDS_KEY_PREV:
	    return LineEdit1_7->text();
	    break;    
	case KLEDS_KEY_NEXT:
	    return LineEdit1_8->text();
	    break;    
	case KLEDS_KEY_MAIL:
	    return LineEdit1_9->text();
	    break;    
	case KLEDS_KEY_SEARCH:
	    return LineEdit1_10->text();
	    break;  
	case KLEDS_KEY_START:
	    return LineEdit1_11->text();
	    break;   
	case KLEDS_KEY_HOME:
	    return LineEdit1_12->text();
	    break;    
    }
    return 0;
}
