/* 
    kleds for KDE2/KDE3

    Copyright (C) 2001,2003 Hans Matzen (hans@hansmatzen.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef __PREFS_H
#define __PREFS_H

#include <qtabwidget.h>
#include <kdialog.h>
#include <kled.h>
#include "kleds.h"

class KColorButton;
class QComboBox;
class QGroupBox;
class QLabel;
class QPushButton;

class Prefs : public KDialog 
{ 
    Q_OBJECT
	
 public:
    Prefs(QWidget* parent = 0, const char* name = 0, 
	   bool modal = FALSE, WFlags fl = 0 );
    ~Prefs();
    /* methods for setting and getting the widget values */
    KLed::Shape get_num_shape();
    KLed::Shape get_caps_shape();
    KLed::Shape get_scroll_shape();
    QColor get_num_color();
    QColor get_caps_color();
    QColor get_scroll_color();
    uint get_label_position();
    QColor get_bg_color();
    uint get_bg_typ();
    QFont get_font();
    QString get_special_key_cmd(int key);

    void set_num_shape(KLed::Shape shape);
    void set_caps_shape(KLed::Shape shape);
    void set_scroll_shape(KLed::Shape shape);
    void set_num_color(QColor col);
    void set_caps_color(QColor col);
    void set_scroll_color(QColor col);
    void set_label_position(uint labpos);
    void set_bg_color(uint typ, QColor col);
    void set_font(QFont font);
    void set_special_key_cmd(int key, QString cmd);

 private:
    QLabel* TextLabel1;
    QPushButton* PushButton1;
    QGroupBox* GroupBox1;
    QGroupBox* GroupBox2;
    QLabel* TextLabel2_2;
    QLabel* TextLabel2_2_2;
    QLabel* TextLabel2_2_2_2;
    KColorButton* KColorButton1;
    KColorButton* KColorButton1_2;
    QLabel* TextLabel2;
    QComboBox* ComboBox1;
    QComboBox* ComboBox1_2_2;
    QComboBox* ComboBox1_2_2_2;
    QComboBox* ComboBox1_2;
    KColorButton* KColorButton1_3;
    QPushButton* PushButton1_2;
    QPushButton* PushButton1_3;
    KColorButton* KColorButton3;
    QLabel* TextLabel3;
    QComboBox* ComboBox3;
    QLabel* TextLabel4;
    QFont* pref_font;
    QPushButton* PushButton4;
    QTabWidget* TabWidget;
    QLabel* TextLabel1_1;
    QLabel* TextLabel1_2;
    QLabel* TextLabel1_3;
    QLabel* TextLabel1_4;
    QLabel* TextLabel1_5;
    QLabel* TextLabel1_6;
    QLabel* TextLabel1_7;
    QLabel* TextLabel1_8;
    QLabel* TextLabel1_9;
    QLabel* TextLabel1_10;
    QLabel* TextLabel1_11;
    QLabel* TextLabel1_12;
    QLineEdit* LineEdit1_1;
    QLineEdit* LineEdit1_2; 
    QLineEdit* LineEdit1_3; 
    QLineEdit* LineEdit1_4; 
    QLineEdit* LineEdit1_5; 
    QLineEdit* LineEdit1_6; 
    QLineEdit* LineEdit1_7; 
    QLineEdit* LineEdit1_8; 
    QLineEdit* LineEdit1_9; 
    QLineEdit* LineEdit1_10; 
    QLineEdit* LineEdit1_11; 
    QLineEdit* LineEdit1_12;

public slots:
    void cancel();
    void ok();
    void config_bgcolchooser(int pos);
    void config_font();
};
#endif 
